/*
 * $Id: $
 *
 * Copyright (c) Critical Software S.A., All Rights Reserved.
 * (www.criticalsoftware.com)
 *
 * This software is the proprietary information of Critical Software S.A.
 * Use is subject to license terms.
 *
 * Last changed on: $Date: $
 * Last changed by: $Author: $
 */
package com.test;

import java.util.HashMap;
import java.util.Map;

import org.jbpm.api.Configuration;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.RepositoryService;
import org.jbpm.api.TaskQuery;
import org.jbpm.api.TaskService;
import org.jbpm.api.task.Task;

/**
 * @author : jmferreira
 * @version : $Revision: $
 */
public class Main {

    public static ProcessEngine processEngine;

    public static void main(final String[] args) throws Exception {
        processEngine = new Configuration().setResource("jbpm.cfg.xml").buildProcessEngine();

        // Get Repository Service
        RepositoryService repositoryService = processEngine.getRepositoryService();

        // Get Execution Service
        final ExecutionService executionService = processEngine.getExecutionService();

        // Get Task Service
        final TaskService taskService = processEngine.getTaskService();

        // Deploy Process
        repositoryService.createDeployment().addResourceFromClasspath("test3.jpdl.xml").deploy();

        Map<String, Object> variables = new HashMap<String, Object>();
        variables.put("montante", 10001L);

        // Start Process Instance
        ProcessInstance processInstance = executionService.startProcessInstanceByKey("test3", variables);

        TaskQuery taskQuery = taskService.createTaskQuery().processInstanceId(processInstance.getId());
        Task task = taskQuery.uniqueResult();

        if (!"a".equals(task.getAssignee())) {
            throw new IllegalArgumentException();
        }

        // taskService.takeTask(task.getId(), "a");

        //
        // taskService.assignTask(task.getId(), "b");
        //
        // taskService.assignTask(task.getId(), "c");

        // Thread.sleep(6000); // give time for the event (timer with 3 seconds) to run and call the event listener.

        taskService.completeTask(task.getId());

        taskQuery = taskService.createTaskQuery().processInstanceId(processInstance.getId());
        task = taskQuery.uniqueResult();

        if (!"task2".equals(task.getName())) {
            throw new IllegalArgumentException();
        }

        taskService.takeTask(task.getId(), "b");

        taskService.completeTask(task.getId());
        
        System.out.println("Finished!");
    }

}
